<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'VertragsdatenAbfrage' => '\\StructType\\VertragsdatenAbfrage',
            'VertragsdatenAntwort' => '\\StructType\\VertragsdatenAntwort',
            'Ruecknahmeangebot' => '\\StructType\\Ruecknahmeangebot',
            'RuecknahmeangebotAntwort' => '\\StructType\\RuecknahmeangebotAntwort',
            'VerfuegbarkeitsanfrageEinzelne' => '\\StructType\\VerfuegbarkeitsanfrageEinzelne',
            'Artikel' => '\\StructType\\Artikel',
            'VerfuegbarkeitsanfrageEinzelneAntwort' => '\\StructType\\VerfuegbarkeitsanfrageEinzelneAntwort',
            'VerfuegbarkeitsanfrageBulk' => '\\StructType\\VerfuegbarkeitsanfrageBulk',
            'VerfuegbarkeitsanfrageBulkAntwort' => '\\StructType\\VerfuegbarkeitsanfrageBulkAntwort',
            'Bestellung' => '\\StructType\\Bestellung',
            'BestellungAntwort' => '\\StructType\\BestellungAntwort',
            'BestellstatusAntwort' => '\\StructType\\BestellstatusAntwort',
            'DokumentAbfragenType' => '\\StructType\\DokumentAbfragenType',
            'DokumentAbfragenAntwort' => '\\StructType\\DokumentAbfragenAntwort',
            'LieferavisAbfrageHistAbfrage' => '\\StructType\\LieferavisAbfrageHistAbfrage',
            'LieferavisAbfragenAntwort' => '\\StructType\\LieferavisAbfragenAntwort',
            'Lieferavis' => '\\StructType\\Lieferavis',
            'Zeile' => '\\StructType\\Zeile',
            'Anteil' => '\\StructType\\Anteil',
            'Fehlmenge' => '\\StructType\\Fehlmenge',
            'LieferavisBestaetigenType' => '\\StructType\\LieferavisBestaetigenType',
            'RetourenavisAnfrageType' => '\\StructType\\RetourenavisAnfrageType',
            'RetourenavisAnfrageAntwort' => '\\StructType\\RetourenavisAnfrageAntwort',
            'Position' => '\\StructType\\Position',
            'RetourenavisAnkuendigungType' => '\\StructType\\RetourenavisAnkuendigungType',
            'RetourenavisAnkuendigungAntwort' => '\\StructType\\RetourenavisAnkuendigungAntwort',
            'RetourenAnteil' => '\\StructType\\RetourenAnteil',
            'SondertagBestellfenster' => '\\StructType\\SondertagBestellfenster',
            'TypSondertag' => '\\StructType\\TypSondertag',
            'VertragsdatenBestellfenster' => '\\StructType\\VertragsdatenBestellfenster',
            'VertragsdatenHauptbestellzeit' => '\\StructType\\VertragsdatenHauptbestellzeit',
            'VertragsdatenAuftragsartNormal' => '\\StructType\\VertragsdatenAuftragsartNormal',
            'VertragsdatenAuftragsart' => '\\StructType\\VertragsdatenAuftragsart',
            'VertragsdatenAuftragsartVersand' => '\\StructType\\VertragsdatenAuftragsartVersand',
            'BestellungAuftrag' => '\\StructType\\BestellungAuftrag',
            'BestellungPosition' => '\\StructType\\BestellungPosition',
            'BestellungAntwortAuftrag' => '\\StructType\\BestellungAntwortAuftrag',
            'BestellungAntwortPosition' => '\\StructType\\BestellungAntwortPosition',
            'BestellungAnteil' => '\\StructType\\BestellungAnteil',
            'VerfuegbarkeitsantwortArtikel' => '\\StructType\\VerfuegbarkeitsantwortArtikel',
            'VerfuegbarkeitAnteil' => '\\StructType\\VerfuegbarkeitAnteil',
            'ArtikelMenge' => '\\StructType\\ArtikelMenge',
            'VerfuegbarkeitSubstitution' => '\\StructType\\VerfuegbarkeitSubstitution',
            'BestellungSubstitution' => '\\StructType\\BestellungSubstitution',
            'Msv3FaultInfo' => '\\StructType\\Msv3FaultInfo',
            'RetourePositionType' => '\\StructType\\RetourePositionType',
            'verbindungTesten' => '\\StructType\\VerbindungTesten',
            'verbindungTestenResponse' => '\\StructType\\VerbindungTestenResponse',
            'verfuegbarkeitAnfragen' => '\\StructType\\VerfuegbarkeitAnfragen',
            'verfuegbarkeitAnfragenResponse' => '\\StructType\\VerfuegbarkeitAnfragenResponse',
            'bestellstatusAbfragen' => '\\StructType\\BestellstatusAbfragen',
            'bestellstatusAbfragenResponse' => '\\StructType\\BestellstatusAbfragenResponse',
            'vertragsdatenAbfragen' => '\\StructType\\VertragsdatenAbfragen',
            'vertragsdatenAbfragenResponse' => '\\StructType\\VertragsdatenAbfragenResponse',
            'bestellen' => '\\StructType\\Bestellen',
            'bestellenResponse' => '\\StructType\\BestellenResponse',
            'verfuegbarkeitAnfragenBulk' => '\\StructType\\VerfuegbarkeitAnfragenBulk',
            'verfuegbarkeitAnfragenBulkResponse' => '\\StructType\\VerfuegbarkeitAnfragenBulkResponse',
            'ruecknahmeangebotAnfordern' => '\\StructType\\RuecknahmeangebotAnfordern',
            'ruecknahmeangebotAnfordernResponse' => '\\StructType\\RuecknahmeangebotAnfordernResponse',
            'lieferavisAbfrageNeu' => '\\StructType\\LieferavisAbfrageNeu',
            'lieferavisAbfrageNeuResponse' => '\\StructType\\LieferavisAbfrageNeuResponse',
            'lieferavisBestaetigen' => '\\StructType\\LieferavisBestaetigen',
            'Void' => '\\StructType\\Void',
            'lieferavisBestaetigenResponse' => '\\StructType\\LieferavisBestaetigenResponse',
            'lieferavisAbfrageHist' => '\\StructType\\LieferavisAbfrageHist',
            'lieferavisAbfrageHistResponse' => '\\StructType\\LieferavisAbfrageHistResponse',
            'retourenavisAnfragen' => '\\StructType\\RetourenavisAnfragen',
            'retourenavisAnfragenResponse' => '\\StructType\\RetourenavisAnfragenResponse',
            'retourenavisAnkuendigen' => '\\StructType\\RetourenavisAnkuendigen',
            'retourenavisAnkuendigenResponse' => '\\StructType\\RetourenavisAnkuendigenResponse',
            'dokumentAbfragen' => '\\StructType\\DokumentAbfragen',
            'dokumentAbfragenResponse' => '\\StructType\\DokumentAbfragenResponse',
            'ServerFaultInfo' => '\\StructType\\ServerFaultInfo',
            'ValidationFaultInfo' => '\\StructType\\ValidationFaultInfo',
            'DenialOfServiceFault' => '\\StructType\\DenialOfServiceFault',
            'AuthorizationFaultInfo' => '\\StructType\\AuthorizationFaultInfo',
            'LieferscheinOderBarcodeUnbekanntFaultInfo' => '\\StructType\\LieferscheinOderBarcodeUnbekanntFaultInfo',
        );
    }
}
