<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BestellungSubstitution StructType
 * @subpackage Structs
 */
class BestellungSubstitution extends AbstractStructBase
{
    /**
     * The Substitutionsgrund
     * @var string
     */
    public $Substitutionsgrund;
    /**
     * The Grund
     * @var string
     */
    public $Grund;
    /**
     * The LieferPzn
     * Meta informations extracted from the WSDL
     * - documentation: PZN die bei einer Bestellung geliefert werden wuerde. | PZN oder auch EAN TODO: Restrictions einbauen.
     * @var int
     */
    public $LieferPzn;
    /**
     * Constructor method for BestellungSubstitution
     * @uses BestellungSubstitution::setSubstitutionsgrund()
     * @uses BestellungSubstitution::setGrund()
     * @uses BestellungSubstitution::setLieferPzn()
     * @param string $substitutionsgrund
     * @param string $grund
     * @param int $lieferPzn
     */
    public function __construct($substitutionsgrund = null, $grund = null, $lieferPzn = null)
    {
        $this
            ->setSubstitutionsgrund($substitutionsgrund)
            ->setGrund($grund)
            ->setLieferPzn($lieferPzn);
    }
    /**
     * Get Substitutionsgrund value
     * @return string|null
     */
    public function getSubstitutionsgrund()
    {
        return $this->Substitutionsgrund;
    }
    /**
     * Set Substitutionsgrund value
     * @uses \EnumType\Substitutionsgrund::valueIsValid()
     * @uses \EnumType\Substitutionsgrund::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $substitutionsgrund
     * @return \StructType\BestellungSubstitution
     */
    public function setSubstitutionsgrund($substitutionsgrund = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Substitutionsgrund::valueIsValid($substitutionsgrund)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $substitutionsgrund, implode(', ', \EnumType\Substitutionsgrund::getValidValues())), __LINE__);
        }
        $this->Substitutionsgrund = $substitutionsgrund;
        return $this;
    }
    /**
     * Get Grund value
     * @return string|null
     */
    public function getGrund()
    {
        return $this->Grund;
    }
    /**
     * Set Grund value
     * @uses \EnumType\BestellungDefektgrund::valueIsValid()
     * @uses \EnumType\BestellungDefektgrund::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $grund
     * @return \StructType\BestellungSubstitution
     */
    public function setGrund($grund = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\BestellungDefektgrund::valueIsValid($grund)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $grund, implode(', ', \EnumType\BestellungDefektgrund::getValidValues())), __LINE__);
        }
        $this->Grund = $grund;
        return $this;
    }
    /**
     * Get LieferPzn value
     * @return int|null
     */
    public function getLieferPzn()
    {
        return $this->LieferPzn;
    }
    /**
     * Set LieferPzn value
     * @param int $lieferPzn
     * @return \StructType\BestellungSubstitution
     */
    public function setLieferPzn($lieferPzn = null)
    {
        // validation for constraint: int
        if (!is_null($lieferPzn) && !is_numeric($lieferPzn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($lieferPzn)), __LINE__);
        }
        $this->LieferPzn = $lieferPzn;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BestellungSubstitution
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
