<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for dokumentAbfragen StructType
 * Meta informations extracted from the WSDL
 * - type: tns:dokumentAbfragen
 * @subpackage Structs
 */
class DokumentAbfragen extends AbstractStructBase
{
    /**
     * The clientSoftwareKennung
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - minOccurs: 0
     * @var string
     */
    public $clientSoftwareKennung;
    /**
     * The dokumentAbfragenType
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - minOccurs: 0
     * @var \StructType\DokumentAbfragenType
     */
    public $dokumentAbfragenType;
    /**
     * Constructor method for dokumentAbfragen
     * @uses DokumentAbfragen::setClientSoftwareKennung()
     * @uses DokumentAbfragen::setDokumentAbfragenType()
     * @param string $clientSoftwareKennung
     * @param \StructType\DokumentAbfragenType $dokumentAbfragenType
     */
    public function __construct($clientSoftwareKennung = null, \StructType\DokumentAbfragenType $dokumentAbfragenType = null)
    {
        $this
            ->setClientSoftwareKennung($clientSoftwareKennung)
            ->setDokumentAbfragenType($dokumentAbfragenType);
    }
    /**
     * Get clientSoftwareKennung value
     * @return string|null
     */
    public function getClientSoftwareKennung()
    {
        return $this->clientSoftwareKennung;
    }
    /**
     * Set clientSoftwareKennung value
     * @param string $clientSoftwareKennung
     * @return \StructType\DokumentAbfragen
     */
    public function setClientSoftwareKennung($clientSoftwareKennung = null)
    {
        // validation for constraint: string
        if (!is_null($clientSoftwareKennung) && !is_string($clientSoftwareKennung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($clientSoftwareKennung)), __LINE__);
        }
        $this->clientSoftwareKennung = $clientSoftwareKennung;
        return $this;
    }
    /**
     * Get dokumentAbfragenType value
     * @return \StructType\DokumentAbfragenType|null
     */
    public function getDokumentAbfragenType()
    {
        return $this->dokumentAbfragenType;
    }
    /**
     * Set dokumentAbfragenType value
     * @param \StructType\DokumentAbfragenType $dokumentAbfragenType
     * @return \StructType\DokumentAbfragen
     */
    public function setDokumentAbfragenType(\StructType\DokumentAbfragenType $dokumentAbfragenType = null)
    {
        $this->dokumentAbfragenType = $dokumentAbfragenType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DokumentAbfragen
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
