<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetourenavisAnkuendigungAntwort StructType
 * Meta informations extracted from the WSDL
 * - documentation: Antwort(en) zu einer RetourenAnkuendigung
 * @subpackage Structs
 */
class RetourenavisAnkuendigungAntwort extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - documentation: ID der Anfrage | eindeutige sich nie wiederholende ID des Webservicerequests. (Fuer Benutzung bei AF2 - Nachtraegliche Antwortabfrage fuer eine Bestellung) Datentyp GUID (Primaerschluessel)
     * - use: required
     * - length: 36
     * - pattern: ([0-9a-fA-F]){8}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){12}
     * @var string
     */
    public $ID;
    /**
     * The RetoureSupportID
     * Meta informations extracted from the WSDL
     * - documentation: ausschliessliche Identifikation fuer Menschen! Support - keine technische Semantik Apo-Wawi vergibt diese; soll genuegend Selektiv sein
     * - use: required
     * - maxInclusive: 999999
     * - minInclusive: 1
     * @var int
     */
    public $RetoureSupportID;
    /**
     * The RetourenAnteil
     * Meta informations extracted from the WSDL
     * - maxOccurs: 15
     * @var \StructType\RetourenAnteil[]
     */
    public $RetourenAnteil;
    /**
     * Constructor method for RetourenavisAnkuendigungAntwort
     * @uses RetourenavisAnkuendigungAntwort::setID()
     * @uses RetourenavisAnkuendigungAntwort::setRetoureSupportID()
     * @uses RetourenavisAnkuendigungAntwort::setRetourenAnteil()
     * @param string $iD
     * @param int $retoureSupportID
     * @param \StructType\RetourenAnteil[] $retourenAnteil
     */
    public function __construct($iD = null, $retoureSupportID = null, array $retourenAnteil = array())
    {
        $this
            ->setID($iD)
            ->setRetoureSupportID($retoureSupportID)
            ->setRetourenAnteil($retourenAnteil);
    }
    /**
     * Get ID value
     * @return string
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\RetourenavisAnkuendigungAntwort
     */
    public function setID($iD = null)
    {
        // validation for constraint: length
        if ((is_scalar($iD) && strlen($iD) !== 36) || (is_array($iD) && count($iD) !== 36)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 36 element(s) or a scalar of 36 character(s)', __LINE__);
        }
        // validation for constraint: pattern
        if (is_scalar($iD) && !preg_match('/([0-9a-fA-F]){8}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){12}/', $iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "([0-9a-fA-F]){8}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){4}-([0-9a-fA-F]){12}", "%s" given', var_export($iD, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get RetoureSupportID value
     * @return int
     */
    public function getRetoureSupportID()
    {
        return $this->RetoureSupportID;
    }
    /**
     * Set RetoureSupportID value
     * @param int $retoureSupportID
     * @return \StructType\RetourenavisAnkuendigungAntwort
     */
    public function setRetoureSupportID($retoureSupportID = null)
    {
        // validation for constraint: maxInclusive
        if ($retoureSupportID > 999999) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be inferior or equal to 999999, "%s" given', $retoureSupportID), __LINE__);
        }
        // validation for constraint: minInclusive
        if ($retoureSupportID < 1) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be superior or equal to 1, "%s" given', $retoureSupportID), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($retoureSupportID) && !is_numeric($retoureSupportID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($retoureSupportID)), __LINE__);
        }
        $this->RetoureSupportID = $retoureSupportID;
        return $this;
    }
    /**
     * Get RetourenAnteil value
     * @return \StructType\RetourenAnteil[]|null
     */
    public function getRetourenAnteil()
    {
        return $this->RetourenAnteil;
    }
    /**
     * Set RetourenAnteil value
     * @throws \InvalidArgumentException
     * @param \StructType\RetourenAnteil[] $retourenAnteil
     * @return \StructType\RetourenavisAnkuendigungAntwort
     */
    public function setRetourenAnteil(array $retourenAnteil = array())
    {
        foreach ($retourenAnteil as $retourenavisAnkuendigungAntwortRetourenAnteilItem) {
            // validation for constraint: itemType
            if (!$retourenavisAnkuendigungAntwortRetourenAnteilItem instanceof \StructType\RetourenAnteil) {
                throw new \InvalidArgumentException(sprintf('The RetourenAnteil property can only contain items of \StructType\RetourenAnteil, "%s" given', is_object($retourenavisAnkuendigungAntwortRetourenAnteilItem) ? get_class($retourenavisAnkuendigungAntwortRetourenAnteilItem) : gettype($retourenavisAnkuendigungAntwortRetourenAnteilItem)), __LINE__);
            }
        }
        $this->RetourenAnteil = $retourenAnteil;
        return $this;
    }
    /**
     * Add item to RetourenAnteil value
     * @throws \InvalidArgumentException
     * @param \StructType\RetourenAnteil $item
     * @return \StructType\RetourenavisAnkuendigungAntwort
     */
    public function addToRetourenAnteil(\StructType\RetourenAnteil $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetourenAnteil) {
            throw new \InvalidArgumentException(sprintf('The RetourenAnteil property can only contain items of \StructType\RetourenAnteil, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RetourenAnteil[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RetourenavisAnkuendigungAntwort
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
