<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VertragsdatenAbfrage StructType
 * Meta informations extracted from the WSDL
 * - documentation: Abfrage Vertragsdaten fuer MSV3 inklusive Sondertage
 * @subpackage Structs
 */
class VertragsdatenAbfrage extends AbstractStructBase
{
    /**
     * The AutomatischerAbruf
     * Meta informations extracted from the WSDL
     * - documentation: Angabe, ob der Vertragsdatenabruf aus dem automatischen taeglichen Abruf erfolgt ist oder manuell ausgeloest wurde.
     * - use: required
     * @var bool
     */
    public $AutomatischerAbruf;
    /**
     * Constructor method for VertragsdatenAbfrage
     * @uses VertragsdatenAbfrage::setAutomatischerAbruf()
     * @param bool $automatischerAbruf
     */
    public function __construct($automatischerAbruf = null)
    {
        $this
            ->setAutomatischerAbruf($automatischerAbruf);
    }
    /**
     * Get AutomatischerAbruf value
     * @return bool
     */
    public function getAutomatischerAbruf()
    {
        return $this->AutomatischerAbruf;
    }
    /**
     * Set AutomatischerAbruf value
     * @param bool $automatischerAbruf
     * @return \StructType\VertragsdatenAbfrage
     */
    public function setAutomatischerAbruf($automatischerAbruf = null)
    {
        // validation for constraint: boolean
        if (!is_null($automatischerAbruf) && !is_bool($automatischerAbruf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($automatischerAbruf)), __LINE__);
        }
        $this->AutomatischerAbruf = $automatischerAbruf;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VertragsdatenAbfrage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
