<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VertragsdatenHauptbestellzeit StructType
 * @subpackage Structs
 */
class VertragsdatenHauptbestellzeit extends AbstractStructBase
{
    /**
     * The Tag
     * @var string
     */
    public $Tag;
    /**
     * The Zeitpunkt
     * Meta informations extracted from the WSDL
     * - documentation: es duerfen nur ganze Minuten angegeben werden! Als technische Reserve zaehlt eine Bestellung noch zum alten Bestellfenster, wenn die Bestelluebertragung beim GH bis zur angegebenen Zeit + 59Sekunden startet. | Es duerfen nur ganze
     * Minuten angegeben werden! Als technische Reserve zaehlt eine Bestellung noch zum alten Bestellfenster, wenn die Bestelluebertragung beim GH bis zur angegebenen Zeit + 59Sekunden startet.
     * - pattern: \d\d:\d\d:00
     * @var string
     */
    public $Zeitpunkt;
    /**
     * Constructor method for VertragsdatenHauptbestellzeit
     * @uses VertragsdatenHauptbestellzeit::setTag()
     * @uses VertragsdatenHauptbestellzeit::setZeitpunkt()
     * @param string $tag
     * @param string $zeitpunkt
     */
    public function __construct($tag = null, $zeitpunkt = null)
    {
        $this
            ->setTag($tag)
            ->setZeitpunkt($zeitpunkt);
    }
    /**
     * Get Tag value
     * @return string|null
     */
    public function getTag()
    {
        return $this->Tag;
    }
    /**
     * Set Tag value
     * @uses \EnumType\VertragsdatenTag::valueIsValid()
     * @uses \EnumType\VertragsdatenTag::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tag
     * @return \StructType\VertragsdatenHauptbestellzeit
     */
    public function setTag($tag = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\VertragsdatenTag::valueIsValid($tag)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $tag, implode(', ', \EnumType\VertragsdatenTag::getValidValues())), __LINE__);
        }
        $this->Tag = $tag;
        return $this;
    }
    /**
     * Get Zeitpunkt value
     * @return string|null
     */
    public function getZeitpunkt()
    {
        return $this->Zeitpunkt;
    }
    /**
     * Set Zeitpunkt value
     * @param string $zeitpunkt
     * @return \StructType\VertragsdatenHauptbestellzeit
     */
    public function setZeitpunkt($zeitpunkt = null)
    {
        // validation for constraint: pattern
        if (is_scalar($zeitpunkt) && !preg_match('/\\d\\d:\\d\\d:00/', $zeitpunkt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\d\d:\d\d:00", "%s" given', var_export($zeitpunkt, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($zeitpunkt) && !is_string($zeitpunkt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zeitpunkt)), __LINE__);
        }
        $this->Zeitpunkt = $zeitpunkt;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VertragsdatenHauptbestellzeit
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
